/*
 * Copyright 2005, Mamezou Co.,LTD.
 */
package jp.co.thinkit.employee.business;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.seasar.framework.exception.SRuntimeException;

/**
 * ]ƈǗ̃rWlXNX
 * @author Mamezou
 * @version 1.0
 */
public class EmployeeManagerImpl implements EmployeeManager {
    // pDAOBS2ɂăCWFNVB
    private EmployeeDao employeeDao;
    
    // Ȍ͉fIȊ֐Sł
    public static Log log = LogFactory.getLog(EmployeeManagerImpl.class);  

    // DAOp̃Zb^[CWFNV
    public void setEmployeeDao(EmployeeDao employeeDao) {
        this.employeeDao = employeeDao;
    }

    /**
     * SĂ̏]ƈB
     * (OO͉fIȊ֐Sł)
     * @return SĂ̏]ƈ
     */
    public List findAll() {
        log.trace("Start findAll() Seasar");
        List emps = null;
        try {
            // SĂ̏]ƈB
            emps = employeeDao.findAll();
        } catch(SRuntimeException e) {
            log.error(e);
            throw e;
        }
        log.trace("End findAll() Seasar");
        return emps;
    }

    /**
     * ]ƈǉB
     * (OO͉fIȊ֐Sł)
     * @param emp ]ƈNX
     * @return ǉ]ƈiK1j
     */
    public int addEmployee(Employee emp) {
        log.trace("Start addEmployee() Seasar");
        int addCount = 0;
        try {
            // ]ƈǉB
            addCount = employeeDao.addEmployee(emp);
        }catch(SRuntimeException e) {
            log.error(e);
            throw e;
        }
        
        log.trace("End addEmployee() Seasar");
        return addCount;
    }

    /**
     * ]ƈ폜B
     * (OO͉fIȊ֐Sł)
     * @param emp ]ƈNX
     * @return 폜]ƈiK1j
     */
    public int removeEmployee(Employee emp) {
        log.trace("Start removeEmployee() Seasar");
        int deleteCount = 0;
        try {
        	    deleteCount = employeeDao.removeEmployee(emp);
        }catch(SRuntimeException e) {
            log.error(e);
            throw e;
        }

        log.trace("End removeEmployee() Seasar");
        return deleteCount;
    }
}